﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Services.Hive.Common;
using System.Transactions;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.DataAccess {
  public class TransactionManager {
    public Disposable<TransactionScope> OpenTransaction() {
      TransactionScope transaction = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.IsolationLevelScope });
      var disposable = new Disposable<TransactionScope>(transaction);
      disposable.Disposing += disposable_Disposing;
      return disposable;
    }

    void disposable_Disposing(object sender, EventArgs<TransactionScope> scope) {
      scope.Value.Complete();
      scope.Value.Dispose();
    }
  }
}
